#include "testlib.h"
#include <string>
#include <vector>
#include <cassert>
constexpr int maxn = 1 << 23;
constexpr bool chk(const int p){return p >= 0 && p < maxn;}
int reg[maxn];

struct Value{
    std::string opt;
    int v;
    int& get(){
        if(opt == "@")return v;
        if(opt == "$"){
            if(!chk(v))quitf(_wa,"Runtime Error");
            return reg[v];
        }
        if(opt == "#"){
            if(!chk(v))quitf(_wa,"Runtime Error");
            if(!chk(reg[v]))quitf(_wa,"Runtime Error");
            return reg[reg[v]];
        }
        assert(false);
    }
    bool is_literal()const{return opt == "@";}
};

Value read_value(){
    Value res;
    res.opt = inf.readToken("@|$|#");
    res.v = inf.readInt();
    return res;
}
struct Instruction{
    std::string opt;

    Value a,b,c,t;

};
std::vector<Instruction> text;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    text.resize(1);
    while(!inf.seekEof()){
        Instruction now;
        now.opt = inf.readToken();
        if(now.opt == "="){
            now.a = read_value();
            now.b = read_value();
        }else if(now.opt == "getc" || now.opt == "geti" || now.opt == "putc" || now.opt == "puti"){
            now.c = read_value();
        }else if(now.opt == "if"){
            now.c = read_value();
            now.t = read_value();
        }else if(now.opt == "+" || now.opt == "-" || now.opt == "*" || now.opt == "/" || now.opt == "<" || now.opt == "=="){
            now.a = read_value();
            now.b = read_value();
            now.c = read_value();
        }
        text.push_back(now);
    }

    int ptr = 1,cnt = 0,ok = 0;
    std::string stk;
    while(true){
        if(ptr == -1)break;
        if(ptr < 1 || ptr >= text.size())quitf(_wa,"Runtime Error");
        if(++cnt > 10000000)quitf(_wa,"Time Limit Exceeded");
        auto ins = text[ptr];
        if(ins.opt == "="){
            if(ins.a.is_literal())quitf(_wa,"Runtime Error");
            ins.a.get() = ins.b.get();
            ptr++;
        }else if(ins.opt == "getc"){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            ins.c.get() = ouf.readChar();
            ptr++;
        }else if(ins.opt == "geti"){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            ins.c.get() = ouf.readInt();
            ptr++;
        }else if(ins.opt == "putc"){
            std::putchar((char)ins.c.get());
            ptr++;
        }else if(ins.opt == "puti"){
            std::printf("%d",ins.c.get());
            ptr++;
        }else if(ins.opt == "if"){
            if(ins.c.get() != 0)ptr = ins.t.get();
            else ptr++;
        }else if(ins.opt == "+"){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            ins.c.get() = ins.a.get() + ins.b.get();
            ptr++;
        }else if(ins.opt == "-"){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            ins.c.get() = ins.a.get() - ins.b.get();
            ptr++;
        }else if(ins.opt == "*"){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            ins.c.get() = ins.a.get() * ins.b.get();
            ptr++;
        }else if(ins.opt == "/"){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            if(ins.b.get() == 0)quitf(_wa,"Runtime Error");
            ins.c.get() = ins.a.get() / ins.b.get();
            ptr++;
        }else if(ins.opt == "<"){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            ins.c.get() = ins.a.get() < ins.b.get();
            ptr++;   
        }else if(ins.opt == "=="){
            if(ins.c.is_literal())quitf(_wa,"Runtime Error");
            ins.c.get() = ins.a.get() == ins.b.get();
            ptr++;   
        }
    }
    quitf(_ok,"");
    return 0;
}